"""Change from id pk to guid pk

Revision ID: 5daf3ef38aac
Revises: d3da9ab956d7
Create Date: 2025-03-24 18:13:26.036997

"""
from typing import Sequence, Union

from alembic import op
import sqlalchemy as sa


# revision identifiers, used by Alembic.
revision: str = '5daf3ef38aac'
down_revision: Union[str, None] = 'd3da9ab956d7'
branch_labels: Union[str, Sequence[str], None] = None
depends_on: Union[str, Sequence[str], None] = None


def upgrade() -> None:
    """Upgrade schema."""
    # ### commands auto generated by Alembic - please adjust! ###
    with op.batch_alter_table('activities', schema=None) as batch_op:
        batch_op.add_column(sa.Column('textbook_guid', sa.Uuid(), nullable=False))
        batch_op.drop_constraint('fk_activities_textbook_id_textbooks', type_='foreignkey')
        batch_op.create_foreign_key(batch_op.f('fk_activities_textbook_guid_textbooks'), 'textbooks', ['textbook_guid'], ['guid'])
        batch_op.drop_column('id')
        batch_op.drop_column('textbook_id')

    with op.batch_alter_table('module_activity', schema=None) as batch_op:
        batch_op.alter_column('module_id',
               existing_type=sa.INTEGER(),
               type_=sa.String(),
               existing_nullable=False)
        batch_op.alter_column('activity_id',
               existing_type=sa.INTEGER(),
               type_=sa.String(),
               existing_nullable=False)
        batch_op.drop_constraint('fk_module_activity_activity_id_activities', type_='foreignkey')
        batch_op.drop_constraint('fk_module_activity_module_id_modules', type_='foreignkey')
        batch_op.create_foreign_key(batch_op.f('fk_module_activity_module_id_modules'), 'modules', ['module_id'], ['guid'])
        batch_op.create_foreign_key(batch_op.f('fk_module_activity_activity_id_activities'), 'activities', ['activity_id'], ['guid'])

    with op.batch_alter_table('modules', schema=None) as batch_op:
        batch_op.add_column(sa.Column('textbook_guid', sa.Uuid(), nullable=False))
        batch_op.drop_constraint('fk_modules_textbook_id_textbooks', type_='foreignkey')
        batch_op.create_foreign_key(batch_op.f('fk_modules_textbook_guid_textbooks'), 'textbooks', ['textbook_guid'], ['guid'])
        batch_op.drop_column('id')
        batch_op.drop_column('textbook_id')

    with op.batch_alter_table('textbooks', schema=None) as batch_op:
        batch_op.drop_column('id')

    # ### end Alembic commands ###


def downgrade() -> None:
    """Downgrade schema."""
    # ### commands auto generated by Alembic - please adjust! ###
    with op.batch_alter_table('textbooks', schema=None) as batch_op:
        batch_op.add_column(sa.Column('id', sa.INTEGER(), nullable=False))

    with op.batch_alter_table('modules', schema=None) as batch_op:
        batch_op.add_column(sa.Column('textbook_id', sa.INTEGER(), nullable=False))
        batch_op.add_column(sa.Column('id', sa.INTEGER(), nullable=False))
        batch_op.drop_constraint(batch_op.f('fk_modules_textbook_guid_textbooks'), type_='foreignkey')
        batch_op.create_foreign_key('fk_modules_textbook_id_textbooks', 'textbooks', ['textbook_id'], ['id'])
        batch_op.drop_column('textbook_guid')

    with op.batch_alter_table('module_activity', schema=None) as batch_op:
        batch_op.drop_constraint(batch_op.f('fk_module_activity_activity_id_activities'), type_='foreignkey')
        batch_op.drop_constraint(batch_op.f('fk_module_activity_module_id_modules'), type_='foreignkey')
        batch_op.create_foreign_key('fk_module_activity_module_id_modules', 'modules', ['module_id'], ['id'])
        batch_op.create_foreign_key('fk_module_activity_activity_id_activities', 'activities', ['activity_id'], ['id'])
        batch_op.alter_column('activity_id',
               existing_type=sa.String(),
               type_=sa.INTEGER(),
               existing_nullable=False)
        batch_op.alter_column('module_id',
               existing_type=sa.String(),
               type_=sa.INTEGER(),
               existing_nullable=False)

    with op.batch_alter_table('activities', schema=None) as batch_op:
        batch_op.add_column(sa.Column('textbook_id', sa.INTEGER(), nullable=False))
        batch_op.add_column(sa.Column('id', sa.INTEGER(), nullable=False))
        batch_op.drop_constraint(batch_op.f('fk_activities_textbook_guid_textbooks'), type_='foreignkey')
        batch_op.create_foreign_key('fk_activities_textbook_id_textbooks', 'textbooks', ['textbook_id'], ['id'])
        batch_op.drop_column('textbook_guid')

    # ### end Alembic commands ###
