"""Change from 'module' to 'topic'

Revision ID: 8a3fbf75e80b
Revises: 5daf3ef38aac
Create Date: 2025-03-25 15:40:46.975114

"""
from typing import Sequence, Union

from alembic import op
import sqlalchemy as sa


# revision identifiers, used by Alembic.
revision: str = '8a3fbf75e80b'
down_revision: Union[str, None] = '5daf3ef38aac'
branch_labels: Union[str, Sequence[str], None] = None
depends_on: Union[str, Sequence[str], None] = None


def upgrade() -> None:
    """Upgrade schema."""
    # ### commands auto generated by Alembic - please adjust! ###
    op.create_table('topics',
    sa.Column('guid', sa.Uuid(), nullable=False),
    sa.Column('name', sa.String(), nullable=False),
    sa.Column('outcomes', sa.String(), nullable=False),
    sa.Column('summary', sa.String(), nullable=False),
    sa.Column('textbook_guid', sa.Uuid(), nullable=False),
    sa.ForeignKeyConstraint(['textbook_guid'], ['textbooks.guid'], name=op.f('fk_topics_textbook_guid_textbooks')),
    sa.PrimaryKeyConstraint('guid', name=op.f('pk_topics'))
    )
    op.create_table('topic_activity',
    sa.Column('topic_id', sa.String(), nullable=False),
    sa.Column('activity_id', sa.String(), nullable=False),
    sa.ForeignKeyConstraint(['activity_id'], ['activities.guid'], name=op.f('fk_topic_activity_activity_id_activities')),
    sa.ForeignKeyConstraint(['topic_id'], ['topics.guid'], name=op.f('fk_topic_activity_topic_id_topics')),
    sa.PrimaryKeyConstraint('topic_id', 'activity_id', name=op.f('pk_topic_activity'))
    )
    op.drop_table('modules')
    op.drop_table('module_activity')
    # ### end Alembic commands ###


def downgrade() -> None:
    """Downgrade schema."""
    # ### commands auto generated by Alembic - please adjust! ###
    op.create_table('module_activity',
    sa.Column('module_id', sa.VARCHAR(), nullable=False),
    sa.Column('activity_id', sa.VARCHAR(), nullable=False),
    sa.ForeignKeyConstraint(['activity_id'], ['activities.guid'], name='fk_module_activity_activity_id_activities'),
    sa.ForeignKeyConstraint(['module_id'], ['modules.guid'], name='fk_module_activity_module_id_modules'),
    sa.PrimaryKeyConstraint('module_id', 'activity_id', name='pk_module_activity')
    )
    op.create_table('modules',
    sa.Column('guid', sa.CHAR(length=32), nullable=False),
    sa.Column('textbook_guid', sa.CHAR(length=32), nullable=False),
    sa.Column('name', sa.VARCHAR(), nullable=False),
    sa.Column('outcomes', sa.VARCHAR(), nullable=False),
    sa.Column('summary', sa.VARCHAR(), nullable=False),
    sa.ForeignKeyConstraint(['textbook_guid'], ['textbooks.guid'], name='fk_modules_textbook_guid_textbooks')
    )
    op.drop_table('topic_activity')
    op.drop_table('topics')
    # ### end Alembic commands ###
